Index: instar.yml
===================================================================
--- .binstar.yml	(revision e4f8e57277d4f98f2e899b727780e3b9fd592c95)
+++ 	(revision )
@@ -1,2 +1,0 @@
-package: aubio
-build_targets: conda
Index: ild.sh
===================================================================
--- build.sh	(revision e4f8e57277d4f98f2e899b727780e3b9fd592c95)
+++ 	(revision )
@@ -1,8 +1,0 @@
-make checkwaf
-python waf configure --prefix=$PREFIX
-python waf build
-python waf install
-pushd python/
-python setup.py build
-python setup.py install
-popd
Index: ta.yaml
===================================================================
--- meta.yaml	(revision e4f8e57277d4f98f2e899b727780e3b9fd592c95)
+++ 	(revision )
@@ -1,37 +1,0 @@
-package:
-  name: aubio
-  version: 0.4.3
-
-source:
-  path: .
-  #git_url: https://github.com/aubio/aubio.git
-  #fn: aubio-0.4.2.tar.bz2
-  #url: http://aubio.org/pub/aubio-0.4.2.tar.bz2
-  #md5: c0f6d8355e92669722501c3a762ba548
-  #sha1: aa0d31c58deb92ab03edfc417d903f50f78444d0
-
-requirements:
-  build:
-    - python
-    - setuptools
-    - numpy
-  run:
-    - python
-    - numpy
-
-test:
-  commands:
-    - aubioonset --help
-    - aubiocut --help
-    - aubiopitch --help
-  imports:
-    - aubio
-
-build:
-  detect_binary_files_with_prefix: True
-  number: 1
-
-about:
-  home: https://aubio.org/
-  license: GPL 3
-  summary: "a library for audio labelling"
Index: ripts/conda/.binstar.yml.default
===================================================================
--- scripts/conda/.binstar.yml.default	(revision e4f8e57277d4f98f2e899b727780e3b9fd592c95)
+++ 	(revision )
@@ -1,67 +1,0 @@
-
-## The package attribute specifies a binstar package namespace to build the package to. 
-## This can be specified here or on the command line
-package: aubio
-
-## You can also specify the account to upload to,
-## you must be an admin of that account, this 
-## defaults to your user account
-# user: USERNAME 
-
-#===============================================================================
-# Build Matrix Options
-# These options may be a single item, a list or empty
-# The resulting number of builds is [platform * engine * env] 
-#===============================================================================
-
-## The platforms to build on.
-## platform defaults to linux-64 
-# platform: 
-#  - linux-64
-#  - linux-32
-## The engine are the inital conda packages you want to run with 
-# engine:
-#  - python=2
-#  - python=3
-## The env param is an environment variable list 
-# env:
-#  - MY_ENV=A CC=gcc
-#  - MY_ENV=B
-
-#===============================================================================
-# Script options
-# These options may be broken out into the before_script, script and after_script
-# or not, that is up to you 
-#===============================================================================
-
-## Run before the script
-# before_script:
-#   - echo "before_script!"
-## Put your main computations here!  
-script:
-  - build.sh
-## This will run after the script regardless of the result of script
-## BINSTAR_BUILD_RESULT=[succcess|failure] 
-# after_script:
-#   - echo "The build was a $BINSTAR_BUILD_RESULT" | tee artifact1.txt
-## This will be run only after a successful build
-# after_success:
-#   - echo "after_success!"
-## This will be run only after a build failure
-# after_failure:
-#   - echo "after_failure!"
-
-#===============================================================================
-# Build Results
-# Build results are split into two categories: artifacts and targets
-# You may omit either key and stiff have a successful build
-# They may be a string, list and contain any bash glob
-#===============================================================================
-
-## Build Targets: Upload these files to your binstar package
-## build targets may be a list of files (globs allows) to upload
-## The special build targets 'conda' and 'pypi' may be used to 
-## upload conda builds  
-## e.g. conda is an alias for /opt/anaconda/conda-bld/<os-arch>/*.tar.bz2
-# build_targets:
-#   - conda