Index: tests/src/onset/test-peakpicker.c
===================================================================
--- tests/src/onset/test-peakpicker.c	(revision 175a218dca84c1e346e54650ae09803778c71412)
+++ tests/src/onset/test-peakpicker.c	(revision 158e031b2ce797901e8e4f39ad185c008e4103c2)
@@ -3,5 +3,5 @@
 #include <aubio.h>
 
-int main ()
+int main (void)
 {
   uint_t win_s = 1024; // window size
Index: tests/src/pitch/test-pitch.c
===================================================================
--- tests/src/pitch/test-pitch.c	(revision 175a218dca84c1e346e54650ae09803778c71412)
+++ tests/src/pitch/test-pitch.c	(revision 158e031b2ce797901e8e4f39ad185c008e4103c2)
@@ -1,5 +1,5 @@
 #include <aubio.h>
 
-int main ()
+int main (void)
 {
   // 1. allocate some memory
Index: tests/src/pitch/test-pitchfcomb.c
===================================================================
--- tests/src/pitch/test-pitchfcomb.c	(revision 175a218dca84c1e346e54650ae09803778c71412)
+++ tests/src/pitch/test-pitchfcomb.c	(revision 158e031b2ce797901e8e4f39ad185c008e4103c2)
@@ -6,5 +6,5 @@
 #include <aubio.h>
 
-int main ()
+int main (void)
 {
   uint_t i = 0;
Index: tests/src/pitch/test-pitchmcomb.c
===================================================================
--- tests/src/pitch/test-pitchmcomb.c	(revision 175a218dca84c1e346e54650ae09803778c71412)
+++ tests/src/pitch/test-pitchmcomb.c	(revision 158e031b2ce797901e8e4f39ad185c008e4103c2)
@@ -6,5 +6,5 @@
 #include <aubio.h>
 
-int main ()
+int main (void)
 {
   uint_t n = 10; // compute n times
Index: tests/src/pitch/test-pitchschmitt.c
===================================================================
--- tests/src/pitch/test-pitchschmitt.c	(revision 175a218dca84c1e346e54650ae09803778c71412)
+++ tests/src/pitch/test-pitchschmitt.c	(revision 158e031b2ce797901e8e4f39ad185c008e4103c2)
@@ -6,5 +6,5 @@
 #include <aubio.h>
 
-int main ()
+int main (void)
 {
   uint_t n = 10; // compute n times
Index: tests/src/pitch/test-pitchspecacf.c
===================================================================
--- tests/src/pitch/test-pitchspecacf.c	(revision 175a218dca84c1e346e54650ae09803778c71412)
+++ tests/src/pitch/test-pitchspecacf.c	(revision 158e031b2ce797901e8e4f39ad185c008e4103c2)
@@ -6,5 +6,5 @@
 #include <aubio.h>
 
-int main ()
+int main (void)
 {
   uint_t n = 10; // compute n times
Index: tests/src/pitch/test-pitchyin.c
===================================================================
--- tests/src/pitch/test-pitchyin.c	(revision 175a218dca84c1e346e54650ae09803778c71412)
+++ tests/src/pitch/test-pitchyin.c	(revision 158e031b2ce797901e8e4f39ad185c008e4103c2)
@@ -6,5 +6,5 @@
 #include <aubio.h>
 
-int main ()
+int main (void)
 {
   uint_t n = 10; // compute n times
Index: tests/src/pitch/test-pitchyinfft.c
===================================================================
--- tests/src/pitch/test-pitchyinfft.c	(revision 175a218dca84c1e346e54650ae09803778c71412)
+++ tests/src/pitch/test-pitchyinfft.c	(revision 158e031b2ce797901e8e4f39ad185c008e4103c2)
@@ -6,5 +6,5 @@
 #include <aubio.h>
 
-int main ()
+int main (void)
 {
   uint_t n = 10; // compute n times
Index: tests/src/spectral/test-fft.c
===================================================================
--- tests/src/spectral/test-fft.c	(revision 175a218dca84c1e346e54650ae09803778c71412)
+++ tests/src/spectral/test-fft.c	(revision 158e031b2ce797901e8e4f39ad185c008e4103c2)
@@ -1,5 +1,5 @@
 #include <aubio.h>
 
-int main ()
+int main (void)
 {
   uint_t win_s = 8; // window size
Index: tests/src/spectral/test-filterbank.c
===================================================================
--- tests/src/spectral/test-filterbank.c	(revision 175a218dca84c1e346e54650ae09803778c71412)
+++ tests/src/spectral/test-filterbank.c	(revision 158e031b2ce797901e8e4f39ad185c008e4103c2)
@@ -1,5 +1,5 @@
 #include <aubio.h>
 
-int main ()
+int main (void)
 {
   uint_t win_s = 1024; // window size
Index: tests/src/spectral/test-filterbank_mel.c
===================================================================
--- tests/src/spectral/test-filterbank_mel.c	(revision 175a218dca84c1e346e54650ae09803778c71412)
+++ tests/src/spectral/test-filterbank_mel.c	(revision 158e031b2ce797901e8e4f39ad185c008e4103c2)
@@ -1,5 +1,5 @@
 #include <aubio.h>
 
-int main ()
+int main (void)
 {
   uint_t samplerate = 16000; // samplerate of signal to filter
Index: tests/src/spectral/test-mfcc.c
===================================================================
--- tests/src/spectral/test-mfcc.c	(revision 175a218dca84c1e346e54650ae09803778c71412)
+++ tests/src/spectral/test-mfcc.c	(revision 158e031b2ce797901e8e4f39ad185c008e4103c2)
@@ -1,5 +1,5 @@
 #include <aubio.h>
 
-int main ()
+int main (void)
 {
   uint_t win_s = 512; // fft size
Index: tests/src/spectral/test-phasevoc.c
===================================================================
--- tests/src/spectral/test-phasevoc.c	(revision 175a218dca84c1e346e54650ae09803778c71412)
+++ tests/src/spectral/test-phasevoc.c	(revision 158e031b2ce797901e8e4f39ad185c008e4103c2)
@@ -1,5 +1,5 @@
 #include <aubio.h>
 
-int main ()
+int main (void)
 {
   uint_t n = 6; // compute n times
Index: tests/src/spectral/test-specdesc.c
===================================================================
--- tests/src/spectral/test-specdesc.c	(revision 175a218dca84c1e346e54650ae09803778c71412)
+++ tests/src/spectral/test-specdesc.c	(revision 158e031b2ce797901e8e4f39ad185c008e4103c2)
@@ -1,5 +1,5 @@
 #include <aubio.h>
 
-int main ()
+int main (void)
 {
   uint_t win_s = 1024; // window size
Index: tests/src/spectral/test-tss.c
===================================================================
--- tests/src/spectral/test-tss.c	(revision 175a218dca84c1e346e54650ae09803778c71412)
+++ tests/src/spectral/test-tss.c	(revision 158e031b2ce797901e8e4f39ad185c008e4103c2)
@@ -1,5 +1,5 @@
 #include <aubio.h>
 
-int main ()
+int main (void)
 {
   uint_t n = 10; // compute n times
Index: tests/src/tempo/test-beattracking.c
===================================================================
--- tests/src/tempo/test-beattracking.c	(revision 175a218dca84c1e346e54650ae09803778c71412)
+++ tests/src/tempo/test-beattracking.c	(revision 158e031b2ce797901e8e4f39ad185c008e4103c2)
@@ -4,5 +4,5 @@
 #include <stdio.h>
 
-int main ()
+int main (void)
 {
   uint_t i = 0;
Index: tests/src/temporal/test-a_weighting.c
===================================================================
--- tests/src/temporal/test-a_weighting.c	(revision 175a218dca84c1e346e54650ae09803778c71412)
+++ tests/src/temporal/test-a_weighting.c	(revision 158e031b2ce797901e8e4f39ad185c008e4103c2)
@@ -1,5 +1,5 @@
 #include <aubio.h>
 
-int main ()
+int main (void)
 {
   
Index: tests/src/temporal/test-biquad.c
===================================================================
--- tests/src/temporal/test-biquad.c	(revision 175a218dca84c1e346e54650ae09803778c71412)
+++ tests/src/temporal/test-biquad.c	(revision 158e031b2ce797901e8e4f39ad185c008e4103c2)
@@ -1,5 +1,5 @@
 #include <aubio.h>
 
-int main ()
+int main (void)
 {
   uint_t win_s = 64; // window size
Index: tests/src/temporal/test-c_weighting.c
===================================================================
--- tests/src/temporal/test-c_weighting.c	(revision 175a218dca84c1e346e54650ae09803778c71412)
+++ tests/src/temporal/test-c_weighting.c	(revision 158e031b2ce797901e8e4f39ad185c008e4103c2)
@@ -1,5 +1,5 @@
 #include <aubio.h>
 
-int main ()
+int main (void)
 {
   aubio_filter_t * f;
Index: tests/src/temporal/test-filter.c
===================================================================
--- tests/src/temporal/test-filter.c	(revision 175a218dca84c1e346e54650ae09803778c71412)
+++ tests/src/temporal/test-filter.c	(revision 158e031b2ce797901e8e4f39ad185c008e4103c2)
@@ -1,5 +1,5 @@
 #include <aubio.h>
 
-int main ()
+int main (void)
 {
   uint_t win_s = 16; // window size
Index: tests/src/temporal/test-resampler.c
===================================================================
--- tests/src/temporal/test-resampler.c	(revision 175a218dca84c1e346e54650ae09803778c71412)
+++ tests/src/temporal/test-resampler.c	(revision 158e031b2ce797901e8e4f39ad185c008e4103c2)
@@ -1,5 +1,5 @@
 #include <aubio.h>
 
-int main ()
+int main (void)
 {
   uint_t win_s = 1024; // window size
Index: tests/src/test-cvec.c
===================================================================
--- tests/src/test-cvec.c	(revision 175a218dca84c1e346e54650ae09803778c71412)
+++ tests/src/test-cvec.c	(revision 158e031b2ce797901e8e4f39ad185c008e4103c2)
@@ -2,5 +2,5 @@
 #include "utils_tests.h"
 
-int main ()
+int main (void)
 {
   uint_t i, window_size = 16; // window size
Index: tests/src/test-delnull.c
===================================================================
--- tests/src/test-delnull.c	(revision 175a218dca84c1e346e54650ae09803778c71412)
+++ tests/src/test-delnull.c	(revision 158e031b2ce797901e8e4f39ad185c008e4103c2)
@@ -5,5 +5,5 @@
 // Programs that call these functions should check for null pointers.
 
-int main ()
+int main (void)
 {
   del_fvec(NULL);
Index: tests/src/test-fmat.c
===================================================================
--- tests/src/test-fmat.c	(revision 175a218dca84c1e346e54650ae09803778c71412)
+++ tests/src/test-fmat.c	(revision 158e031b2ce797901e8e4f39ad185c008e4103c2)
@@ -5,5 +5,5 @@
 // and j the column.
 
-int main ()
+int main (void)
 {
   uint_t height = 3, length = 9, i, j;
Index: tests/src/test-fvec.c
===================================================================
--- tests/src/test-fvec.c	(revision 175a218dca84c1e346e54650ae09803778c71412)
+++ tests/src/test-fvec.c	(revision 158e031b2ce797901e8e4f39ad185c008e4103c2)
@@ -2,5 +2,5 @@
 #include <assert.h>
 
-int main ()
+int main (void)
 {
   uint_t vec_size = 10, i;
Index: tests/src/test-lvec.c
===================================================================
--- tests/src/test-lvec.c	(revision 175a218dca84c1e346e54650ae09803778c71412)
+++ tests/src/test-lvec.c	(revision 158e031b2ce797901e8e4f39ad185c008e4103c2)
@@ -2,5 +2,5 @@
 #include "utils_tests.h"
 
-int main()
+int main (void)
 {
   uint_t win_s = 32; // window size
Index: tests/src/test-mathutils-window.c
===================================================================
--- tests/src/test-mathutils-window.c	(revision 175a218dca84c1e346e54650ae09803778c71412)
+++ tests/src/test-mathutils-window.c	(revision 158e031b2ce797901e8e4f39ad185c008e4103c2)
@@ -3,5 +3,5 @@
 #include <stdio.h>
 
-int main ()
+int main (void)
 {
   uint_t length = 0;
Index: tests/src/test-mathutils.c
===================================================================
--- tests/src/test-mathutils.c	(revision 175a218dca84c1e346e54650ae09803778c71412)
+++ tests/src/test-mathutils.c	(revision 158e031b2ce797901e8e4f39ad185c008e4103c2)
@@ -4,5 +4,5 @@
 #include <aubio.h>
 
-int test_next_power_of_two()
+int test_next_power_of_two (void)
 {
   uint_t a, b;
@@ -25,5 +25,5 @@
 }
 
-int test_miditofreq()
+int test_miditofreq (void)
 {
   smpl_t a, b;
@@ -56,5 +56,5 @@
 }
 
-int test_freqtomidi()
+int test_freqtomidi (void)
 {
   smpl_t midi, freq;
@@ -88,5 +88,5 @@
 }
 
-int test_aubio_window()
+int test_aubio_window (void)
 {
   uint_t window_size = 16;
@@ -108,5 +108,5 @@
 }
 
-int main ()
+int main (void)
 {
   test_next_power_of_two();
Index: tests/src/utils/test-hist.c
===================================================================
--- tests/src/utils/test-hist.c	(revision 175a218dca84c1e346e54650ae09803778c71412)
+++ tests/src/utils/test-hist.c	(revision 158e031b2ce797901e8e4f39ad185c008e4103c2)
@@ -3,5 +3,5 @@
 #include <aubio.h>
 
-int main ()
+int main (void)
 {
   uint_t length;
Index: tests/src/utils/test-parameter.c
===================================================================
--- tests/src/utils/test-parameter.c	(revision 175a218dca84c1e346e54650ae09803778c71412)
+++ tests/src/utils/test-parameter.c	(revision 158e031b2ce797901e8e4f39ad185c008e4103c2)
@@ -21,5 +21,5 @@
 }
 
-int main ()
+int main (void)
 {
   smpl_t max_value = 100.;
Index: tests/src/utils/test-scale.c
===================================================================
--- tests/src/utils/test-scale.c	(revision 175a218dca84c1e346e54650ae09803778c71412)
+++ tests/src/utils/test-scale.c	(revision 158e031b2ce797901e8e4f39ad185c008e4103c2)
@@ -3,5 +3,5 @@
 #include <aubio.h>
 
-int main ()
+int main (void)
 {
   uint_t n = 0;